<!DOCTYPE html>
<html lang="en">
  <head>
    <meta charset="UTF-8" />
    <meta http-equiv="X-UA-Compatible" content="IE=edge" />
    <meta name="viewport" content="width=device-width, initial-scale=1.0" />

    <!-- linking bootstrap -->
    <link
      rel="stylesheet"
      href="https://cdn.jsdelivr.net/npm/bootstrap@4.6.2/dist/css/bootstrap.min.css"
      integrity="sha384-xOolHFLEh07PJGoPkLv1IbcEPTNtaed2xpHsD9ESMhqIYd0nLMwNLD69Npy4HI+N"
      crossorigin="anonymous"
    />

    <title>Bootstrap-Flex</title>
  </head>
  <body>
    <div class="container-fluid text-center">
      <h1>Bootstrap Flex</h1>
      <p>
        use the d-flex class to create a flex container and transform direct
        children into flex items.
      </p>
      <!-- align-items-center - class will vertically center all the child elements. It will only work if the div or container is flex -->
      <!-- justify-content-center - class will horizontally center all the child elements. It will only work if the div or container is flex -->
      <!-- d-flex - the flex value will change the element into block-level container. it will make all the elements become "flexible" that allows them to occupy space enough for the content of an element and at the same time will have the elements appear beside each other. (flex-row/flex-column) -->
      <h2>Flex Column</h2>
      <div
        style="height: 500px"
        class="d-flex flex-column bg-dark align-items-center justify-content-center p-3"
      >
        <div class="p-3 bg-success col-2">Flex Item A</div>
        <div class="p-3 bg-warning col-2">Flex Item B</div>
        <div class="p-3 bg-danger col-2">Flex Item C</div>
      </div>

      <h2 class="mt-5">Flex Row</h2>
      <div style="height: 500px" class="d-flex bg-dark align-items-center p-3">
        <div class="p-3 bg-success">Flex Item A</div>
        <div class="p-3 bg-warning">Flex Item B</div>
        <div class="p-3 bg-danger">Flex Item C</div>
      </div>

      <h2 class="mt-5">Flex Row Reverse</h2>
      <div style="height: 500px" class="d-flex bg-dark flex-row-reverse p-3">
        <div class="p-3 bg-success">Flex Item A</div>
        <div class="p-3 bg-warning">Flex Item B</div>
        <div class="p-3 bg-danger">Flex Item C</div>
      </div>

      <h2 class="mt-5">Create space between elements</h2>
      <div
        style="height: 500px"
        class="d-flex bg-dark justify-content-around p-3"
      >
        <div class="p-3 bg-success">Flex Item A</div>
        <div class="p-3 bg-warning">Flex Item B</div>
        <div class="p-3 bg-danger">Flex Item C</div>
      </div>
      <div
        style="height: 500px"
        class="d-flex bg-dark justify-content-between p-3"
      >
        <div class="p-3 bg-success">Flex Item A</div>
        <div class="p-3 bg-warning">Flex Item B</div>
        <div class="p-3 bg-danger">Flex Item C</div>
      </div>

      <!-- mr-auto - means margin-right auto move the right elements to the right side -->
      <!-- ml-auto - means margin-left auto move the left elements to the left side -->
      <h2>Flexbox with margin</h2>
      <div class="bg-dark d-flex p-3">
        <div class="p-3 bg-success">Flex Item A</div>
        <div class="p-3 bg-warning mr-auto">Flex Item B</div>
        <div class="p-3 bg-danger">Flex Item C</div>
        <div class="p-3 bg-primary">Flex Item D</div>
      </div>

      <h2>Nested Flex Elements</h2>
      <div class="bg-dark d-flex p-3">
        <div class="p-3 bg-success">Flex Item A</div>
        <div class="d-flex flex-row ml-auto">
          <div class="p-3 bg-warning">Flex Item B</div>
          <div class="p-3 bg-danger">Flex Item C</div>
          <div class="p-3 bg-primary">Flex Item D</div>
        </div>
      </div>
    </div>

    <!-- Bootstrap script -->
    <script
      src="https://cdn.jsdelivr.net/npm/jquery@3.5.1/dist/jquery.slim.min.js"
      integrity="sha384-DfXdz2htPH0lsSSs5nCTpuj/zy4C+OGpamoFVy38MVBnE+IbbVYUew+OrCXaRkfj"
      crossorigin="anonymous"
    ></script>
    <script
      src="https://cdn.jsdelivr.net/npm/bootstrap@4.6.2/dist/js/bootstrap.bundle.min.js"
      integrity="sha384-Fy6S3B9q64WdZWQUiU+q4/2Lc9npb8tCaSX9FK7E8HnRr0Jz8D6OP9dO5Vg3Q9ct"
      crossorigin="anonymous"
    ></script>
  </body>
</html>
